/*
  HardwareSerial.h - Hardware serial library for Wiring

  Copyright (c) 2020 Sasapea's Lab. All right reserved.

  System Setting:

    [Oraneg Pi Zeo][/boot/armbianEnv.txt]
    overlays=... uart1 uart2 ...
    param_uart1_rtscts=0
    param_uart2_rtscts=0

    /dev/ttyS0
    /dev/ttyS1
    /dev/ttyS2
    /dev/ttyS3
    /dev/ttyUSB0
    /dev/ttyUSB1
    /dev/ttyUSB2
    /dev/ttyUSB3
    /dev/ttyACM0
    /dev/ttyACM1
    /dev/ttyACM2
    /dev/ttyACM3

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "HardwareSerial.h"

extern void serialEvent(void)     __attribute__((weak));
extern void serialEvent1(void)    __attribute__((weak));
extern void serialEvent2(void)    __attribute__((weak));
extern void serialEvent3(void)    __attribute__((weak));
extern void serialEventUSB(void)  __attribute__((weak));
extern void serialEventUSB1(void) __attribute__((weak));
extern void serialEventUSB2(void) __attribute__((weak));
extern void serialEventUSB3(void) __attribute__((weak));
extern void serialEventACM(void)  __attribute__((weak));
extern void serialEventACM1(void) __attribute__((weak));
extern void serialEventACM2(void) __attribute__((weak));
extern void serialEventACM3(void) __attribute__((weak));
extern void serialEventSTD(void)  __attribute__((weak));

void serialEventRun(void)
{
  if (serialEvent && Serial && Serial.available())
    serialEvent();
  if (serialEvent1 && Serial1 && Serial1.available())
    serialEvent1();
  if (serialEvent2 && Serial2 && Serial2.available())
    serialEvent2();
  if (serialEvent3 && Serial3 && Serial3.available())
    serialEvent3();

  if (serialEventUSB && SerialUSB && SerialUSB.available())
    serialEventUSB();
  if (serialEventUSB1 && SerialUSB1 && SerialUSB1.available())
    serialEventUSB1();
  if (serialEventUSB2 && SerialUSB2 && SerialUSB2.available())
    serialEventUSB2();
  if (serialEventUSB3 && SerialUSB3 && SerialUSB3.available())
    serialEventUSB3();

  if (serialEventACM && SerialACM && SerialACM.available())
    serialEventACM();
  if (serialEventACM1 && SerialACM1 && SerialACM1.available())
    serialEventACM1();
  if (serialEventACM2 && SerialACM2 && SerialACM2.available())
    serialEventACM2();
  if (serialEventACM3 && SerialACM3 && SerialACM3.available())
    serialEventACM3();

  if (serialEventSTD && SerialSTD && SerialSTD.available())
    serialEventSTD();
}

HardwareSerial Serial("/dev/ttyS0");
HardwareSerial Serial1("/dev/ttyS1");
HardwareSerial Serial2("/dev/ttyS2");
HardwareSerial Serial3("/dev/ttyS3");
HardwareSerial SerialUSB("/dev/ttyUSB0");
HardwareSerial SerialUSB1("/dev/ttyUSB1");
HardwareSerial SerialUSB2("/dev/ttyUSB2");
HardwareSerial SerialUSB3("/dev/ttyUSB3");
HardwareSerial SerialACM("/dev/ttyACM0");
HardwareSerial SerialACM1("/dev/ttyACM1");
HardwareSerial SerialACM2("/dev/ttyACM2");
HardwareSerial SerialACM3("/dev/ttyACM3");
HardwareSerial SerialSTD;

