/*
  pins_arduino.h

  Copyright (c) 2020 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef __PINS_ARDUINO_H
#define __PINS_ARDUINO_H

// main.cpp
extern int  __argc;
extern char **__argv;
extern int interrupted(void);

#define PGM_P const char *
#define pgm_read_byte(p) *(p)
#define strcpy_P strcpy
#define strlen_P strlen

#define _BV(b) (1UL << (b))

#define INPUT_PULLDOWN 3

//
// Orange Pi Zero
//
#define PA00   0  // UART2_TX
#define PA01   1  // UART2_RX
#define PA02   2  // UART2_RTS
#define PA03   3  // UART2_CTS
#define PA05   5  // PWM0
#define PA06   6  // 
#define PA07   7  // SIM_CLK / PA_EINT7
#define PA10  10  // SIM_DET / PA_EINT10
#define PA11  11  // TWI0_SCK
#define PA12  12  // TWI0_SDA
#define PA13  13  // SPI1_CS
#define PA14  14  // SPI1_CLK
#define PA15  15  // SPI1_MOSI
#define PA16  16  // SPI1_MISO
#define PA17  17  // ORANGEPI_RED_STATUS
#define PA18  18  // TWI1_SCK
#define PA19  19  // TWI1_SDA
#define PG06 198  // UART1_TX
#define PG07 199  // UART1_RX
#define PL10 362  // ORANGEPI_GREEN_PWR

#define ORANGEPI_ZERO_RED_STATUS PA17
#define ORANGEPI_ZERO_GREEN_PWR  PL10

#define ORANGEPI_ZERO_RED_STATUS_TRIGGER "/sys/class/leds/orangepi:red:status/trigger"
#define ORANGEPI_ZERO_RED_STATUS_NONE    "echo none > " ORANGEPI_ZERO_RED_STATUS_TRIGGER
#define ORANGEPI_ZERO_RED_STATUS_MMC0    "echo mmc0 > " ORANGEPI_ZERO_RED_STATUS_TRIGGER

#endif

