/*
  wiring_shift.c - shiftOut() function
  Part of Arduino - http://www.arduino.cc/

  Copyright (c) 2020      Sasapea's Lab
  Copyright (c) 2005-2006 David A. Mellis

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/

#include "Arduino.h"

uint8_t shiftIn(uint16_t dataPin, uint16_t clockPin, uint8_t bitOrder)
{
  uint8_t value = 0;

  for (uint8_t i = 0; i < 8; ++i)
  {
    digitalWrite(clockPin, HIGH);
    if (bitOrder == LSBFIRST)
      value = (value << 1) | (digitalRead(dataPin) ? 0x01 : 0x00);
    else
      value = (value >> 1) | (digitalRead(dataPin) ? 0x80 : 0x00);
    digitalWrite(clockPin, LOW);
  }
	return value;
}

void shiftOut(uint16_t dataPin, uint16_t clockPin, uint8_t bitOrder, uint8_t val)
{
  for (uint8_t i = 0; i < 8; i++)
  {
    if (bitOrder == LSBFIRST)
    {
			digitalWrite(dataPin, val & 0x01);
      val >>= 1;
    }
    else
    {
      digitalWrite(dataPin, val & 0x80);
      val <<= 1;
    }
    digitalWrite(clockPin, HIGH);
    digitalWrite(clockPin, LOW);
  }
}
