#include <stdio.h>
#include "xtoa.h"

static char format(unsigned char base, char type10)
{
  switch (base)
  {
    case  8: return 'o';
    case 16: return 'x';
  }
  return type10;
}

char *itoa(int n, char *buffer, int radix)
{
  char fmt[] = {'%', format(radix, 'd'), 0};
  sprintf(buffer, fmt, n);
  return buffer;
}

char *utoa(unsigned int n, char *buffer, int radix)
{
  char fmt[] = {'%', format(radix, 'u'), 0};
  sprintf(buffer, fmt, n);
  return buffer;
}

char *ltoa(long l, char *buffer, int radix)
{
  char fmt[] = {'%', 'l', format(radix, 'd'), 0};
  sprintf(buffer, fmt, l);
  return buffer;
}

char *ultoa(unsigned long l, char *buffer, int radix)
{
  char fmt[] = {'%', 'l', format(radix, 'u'), 0};
  sprintf(buffer, fmt, l);
  return buffer;
}

char *dtostrf(double lf, signed char width, unsigned char prec, char *buffer)
{
  sprintf(buffer, "%*.*lf", width, prec, lf);
  return buffer;
}